
const PricePrec = 4;

function SHOWKART(ParentObject : TObject; IdRow, IdLabel : Integer) : word;
var f : TcsForm;
BtnOk,BtnCancel : TBitbtn;
edtKol,edtCena,edtCenaPrice,edtSumma,edtDiscount,edtSummaAll,edtSummaWork,
edtCenaWork : TEditNumber;
MemoDescr : TMemo;
pnlMethod : TcsPanelFewCode;
q : TcsQuery;
lMethod : TLabel;

procedure FormRefresh(Sender : TObject);
begin
 if (Sender = edtCena) or (Sender = edtKol) then
    begin
         edtSumma.Value := AnyRound(edtCena.Value * edtKol.Value,2);
    end
 else
 if (Sender = edtSumma) then
   begin
     if  edtKol.Value > 0.001 then
         edtCena.Value := AnyRound(edtSumma.Value / edtKol.Value,PricePrec)
     else
         edtCena.Value := 0;
   end;
 if (Sender = edtCenaWork) or (Sender = edtKol) then
    begin
         edtSummaWork.Value := AnyRound(edtCenaWork.Value * edtKol.Value,2);
    end
 else
 if (Sender = edtSummaWork) then
   begin
     if  edtKol.Value > 0.001 then
         edtCenaWork.Value := AnyRound(edtSummaWork.Value / edtKol.Value,PricePrec)
     else
         edtCenaWork.Value := 0;
   end;
  edtSummaAll.Value := AnyRound(edtSumma.Value + edtSummaWork.Value,2);
  if edtCenaPrice.Value > 0 then
    edtDiscount.Value := AnyRound((edtCenaPrice.Value - edtCena.Value)/edtCenaPrice.Value*100,PricePrec)
  else
    edtDiscount.Value := 0;
 csVariables['DOCROWKOL'] := edtKol.Value;
 if  (edtKol.Value >= 0.001) then
  csVariables['DOCROWCENA'] :=  AnyRound(edtSummaAll.Value /  edtKol.Value,PricePrec)
 else
 csVariables['DOCROWCENA'] := 0;
 csVariables['DOCROWSUMMA'] :=  AnyRound(edtSummaAll.Value,2);
end;

function CreateEditControl(LabelCaption : String;x,y :Integer) : TEditNumber;
begin
     with TLabel.Create(f) do
          begin
            Parent := f;
            Caption := LabelCaption;
            SetBounds(x,y,120,20);

          end;
     Result :=  TEditNumber.Create(f);
     with Result do
          begin
            Parent := f;
            DecimalCount := PricePrec ;
            DoSeparator := True;
            MaxLength := 14;
            Top := y;
            Left := x+130;
            onExit := @FormRefresh;
          end;
end;
begin

     f := TcsForm.Create(nil);
     pnlMethod := TcsPanelFewCode.create(f);
     lMethod := TLabel.create(f);
     with pnlMethod do
      begin
        parent := f;
        DatabaseName := MainDatabaseName;
        TableName := 'METHODOFMARKING';
        FieldId := 'Id';
        FieldName := 'Name';
        left := 150;
        top := 20;
        width := 455;
      end;
      with lMethod do
      begin
        parent := f;
        left := 20;
        top := 20;
        Caption := ' ';
      end;
     f.Caption := '   ';
     f.Width := 620;
     f.Height := 380;
     f.BorderStyle := bsDialog;
     f.position := poScreenCenter;
     edtKol := CreateEditControl('',20,50);
     if csVariables['DOCROWKOL'] <> null then
     edtKol.Value := csVariables['DOCROWKOL'];

     edtCenaPrice := CreateEditControl('  ',20,80);
//     if csVariables['DOCROWCENAPRICE'] <> null then
     edtCenaPrice.Value := SQLSELECT('select lc.CenaPrice1 from label l left outer join labelcena lc on lc.idlabel = l.IDBASICLABEL and lc.idshop = 1 where l.id = '+IntToStr(IdLabel));
     edtCenaPrice.Enabled := False;
     pnlMethod.ListId := ','+IntToStr(SQLSELECT('select IDPROCESS from label l where l.id = '+IntToStr(IdLabel)))+',';
     edtDiscount := CreateEditControl(' (%)',20,110);
     edtDiscount.Enabled := False;

     edtCena := CreateEditControl('',20,140);
     edtCena.Value := edtCenaPrice.Value;
     edtSumma := CreateEditControl(' ',20,170);

     edtCenaWork := CreateEditControl('   .',20,200);
     edtSummaWork := CreateEditControl(' ',20,230);

     edtSummaAll := CreateEditControl(' ',20,280);
     edtSummaAll.Enabled := False;
     edtSummaAll.font.Color := clBlack;
     edtSummaAll.font.Color := clBlack;
     if csVariables['DOCROWSUMMA'] <> null then
        edtSummaAll.Value := csVariables['DOCROWSUMMA'];

     BtnOk := TBitbtn.Create(f);
     BtnOk.Parent := f;
     BtnOk.Caption := '';
     BtnOk.SetBounds(430,280,80,25);
     BtnOk.ModalResult := mrOk;
     BtnOk.Kind  := bkCustom;
     BtnCancel := TBitbtn.Create(f);
     BtnCancel.Parent := f;
     BtnCancel.Caption := '';
     BtnCancel.SetBounds(520,280,80,25);
     BtnCancel.ModalResult := mrCancel;
     BtnCancel.Kind := bkCancel;
     with TLabel.Create(f) do
          begin
            Parent := f;
            SetBounds(300,20,120,20);
            Caption := ' ';
          end;

     MemoDescr := TMemo.Create(f);
     MemoDescr.Parent := f;
     MemoDescr.Top := 50;
     MemoDescr.Left := 300;
     MemoDescr.MaxLength := 250;
     MemoDescr.Width := 280;
     MemoDescr.Height := 200;
     q := TcsQuery.Create(f);
     q.DatabaseName := MainDatabaseName;
     q.SQL.Add('select * from doc_addinfo where id = '+IntToStr(IdRow));
     q.Open;
     if (q.RecordCount  > 0) then
        begin
          edtKol.Value := q.FieldByName('Kol').AsFloat;
          edtCena.Value := q.FieldByName('Cena').AsFloat;
          edtCenaWork.Value := q.FieldByName('CenaWork').AsFloat;
          edtCenaPrice.Value := q.FieldByName('CenaPrice').AsFloat;
          edtSumma.Value := q.FieldByName('Summa').AsFloat;
          edtSummaWork.Value := q.FieldByName('SummaWork').AsFloat;
          edtSummaAll.Value := q.FieldByName('SummaAll').AsFloat;
          edtDiscount.Value := q.FieldByName('Cenadiscount').AsFloat;
          MemoDescr.Lines.Text := q.FieldByName('Description').AsString;
          pnlMethod.ListId :=  q.FieldByName('LISTIDMETHOD').AsString;
        end;
     FormRefresh(edtKol);
     Result := f.ShowModal;
     if Result = mrOk then
        begin
         if q.RecordCount  > 0  then
            q.Edit
         else
           begin
            q.Append;
            q.FieldByName('Id').AsInteger := IdRow;

           end;
         q.FieldByName('Kol').AsFloat := edtKol.Value;
         q.FieldByName('CenaPrice').AsFloat := edtCenaPrice.Value;
         q.FieldByName('Cenadiscount').AsFloat := edtDiscount.Value;
         q.FieldByName('Cena').AsFloat := edtCena.Value;
         q.FieldByName('Summa').AsFloat := edtSumma.Value;
         q.FieldByName('CenaWork').AsFloat := edtCenaWork.Value;
         q.FieldByName('SummaWork').AsFloat := edtSummaWork.Value;
         q.FieldByName('SummaAll').AsFloat := edtSummaAll.Value;
         q.FieldByName('Description').AsString := MemoDescr.Lines.Text;
         q.FieldByName('LISTIDMETHOD').AsString := pnlMethod.ListId;
         q.Post;
         q.ApplyUpdates;
         q.CommitUpdates;
        end;
     q.Close;
     f.free;
end;


begin

end.